Loading...
Searching...
No Matches
BALL::VIEW::ServerWidget Class Reference
Visualisation » Kernel » Client/Server request handling

`#include <BALL/VIEW/KERNEL/serverWidget.h>`

Inheritance diagram for BALL::VIEW::ServerWidget:

## Classes

class | NotCompositeObject
class | BALLViewServer

## Public Member Functions

Constructors
| ServerWidget (QWidget *parent=0, const char *name=0)
| ServerWidget (const ServerWidget &server)
Destructors
virtual | ~ServerWidget ()
virtual void | clear ()
Accessors: inspectors and mutators
virtual void | activate ()
virtual void | deactivate ()
void | setPort (const int port)
int | getPort () const
void | registerObjectCreator (const ObjectCreator &s)
void | unregisterObjectCreator ()
ObjectCreator & | getObjectCreator ()
const ObjectCreator & | getObjectCreator () const
virtual void | initializeWidget (MainControl &main_control)
virtual void | finalizeWidget (MainControl &main_control)
virtual void | initializePreferencesTab (Preferences &preferences)
virtual void | finalizePreferencesTab (Preferences &preferences)
virtual void | applyPreferences ()
debuggers and diagnostics
virtual bool | isValid () const
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const
virtual void | changeLock (bool lock)
Public Member Functions inherited from BALL::VIEW::ModularWidget
| ModularWidget (const char *name="<ModularWidget>")
| ModularWidget (const ModularWidget &widget)
virtual | ~ModularWidget ()
virtual void | destroy ()
virtual void | checkMenu (MainControl &main_control)
QAction * | insertMenuEntry (Position parent_id, const QString &name, const QObject *receiver=0, const char *slot=0, const String &description="", QKeySequence accel=QKeySequence(), const QString &menu_hint=QString(""), UIOperationMode::OperationMode minimal_mode=UIOperationMode::MODE_ALL)
BALL_DEPRECATED void | setMenuHelp (QAction *, const String &)
virtual BALL_DEPRECATED void | registerForHelpSystem (const QObject *, const String &)
virtual void | addToolBarEntries (QToolBar *main_tb)
void | setIcon (QAction *action, const String &filename, bool add_to_main_toolbar=true)
virtual void | fetchPreferences (INIFile &inifile)
virtual void | writePreferences (INIFile &inifile)
bool | lockComposites ()
bool | unlockComposites ()
| Unlock the Composites.
MainControl * | getMainControl () const
virtual void | setStatusbarText (const String &text, bool important=false)
virtual void | setStatusbarText (const QString &text, bool important=false)
String | getWorkingDir ()
| Implemented for convenience.
void | setWorkingDir (const String &dir)
| Implemented for convenience.
FragmentDB & | getFragmentDB () const
void | setWorkingDirFromFilename_ (String filename)
virtual BALL_DEPRECATED void | showHelp (const String &)
virtual bool | canHandle (const String &) const
virtual bool | openFile (const String &)
Public Member Functions inherited from BALL::Embeddable
| Embeddable (const String &identifier="<Embeddable>")
| Embeddable (const Embeddable &embeddable)
virtual | ~Embeddable ()
void | setIdentifier (const String &identifier)
const String & | getIdentifier () const
void | unregisterThis ()
virtual void | registerThis ()
Public Member Functions inherited from BALL::VIEW::ConnectionObject
| ConnectionObject ()
virtual | ~ConnectionObject ()
void | registerConnectionObject (ConnectionObject &object)
void | unregisterConnectionObject (ConnectionObject &object)
bool | isConnectionObjectRegistered (const ConnectionObject &object)
ConnectionObject * | getParent () const
ConnectionObject * | getRoot ()
virtual void | onNotify (Message *message)

## Signals and Slots

void | handleLocking (bool lock)
void | lockRequested (bool lock)

## Additional Inherited Members

Public Types inherited from BALL::Embeddable
typedef std::vector< Embeddable * > | EmbeddableVector
static void | registerWidget (ModularWidget *mwidget)
void | notify_ (Message *message)
void | notify_ (Message &message)
void | onNotify_ (Message *message)
static void | registerInstance_ (const std::type_info &type, const Embeddable *instance)
static void | unregisterInstance_ (const Embeddable *instance)
static Size | countInstances_ (const std::type_info &type)
static Embeddable * | getInstance_ (const std::type_info &type, Position index)
static Embeddable * | getInstance_ (const std::type_info &type, const String &identifier)
QAction * | window_menu_entry_
bool | show_window_enty_
bool | default_visible_
QList< QAction * > | main_toolbar_actions_

## Detailed Description

ServerWidget class. The class ServerWidget handles all incoming PersistentObject objects, converts them into Composite objects (if possible) and sents them through the ConnectionObject tree with the message NewCompositeMessage. Also it stores all received Composite objects and replaces them if the same Composite object is received again. If a Composite object is replaced the message RemovedCompositeMessage will be sent through the ConnectionObject tree and after that the the message NewCompositeMessage with the new received composite will be sent.

Definition at line 59 of file serverWidget.h.

## Constructor & Destructor Documentation

## ServerWidget() [1/2]

BALL::VIEW::ServerWidget::ServerWidget | ( | QWidget * | parent = 0,
|  | const char * | name = 0 )

Default Constructor. The state of this server is:

- no object creator registered
- server listening on VIEW_DEFAULT_PORT if activated
  See also
    ModularWidget

## ServerWidget() [2/2]

BALL::VIEW::ServerWidget::ServerWidget | ( | const ServerWidget & | server | ) |

## ~ServerWidget()

virtual BALL::VIEW::ServerWidget::~ServerWidget | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## activate()

virtual void BALL::VIEW::ServerWidget::activate | ( |  | ) |

inline virtual

Start the server.

Definition at line 169 of file serverWidget.h.

## applyPreferences()

virtual void BALL::VIEW::ServerWidget::applyPreferences | ( |  | ) |

virtual

Apply the preferences of the specific tab. This method applies the preferences of the own tab ServerPreferences to this server. This method is called automatically by the method applyPreferencesTab of the class MainControl. See ModularWidget for more information concerning preferences tabs.

Parameters

  preferences | the Preferences dialog of the MainControl

See also
  applyPreferencesTab
  ServerPreferences
  Preferences

Reimplemented from BALL::VIEW::ModularWidget.

## changeLock()

virtual void BALL::VIEW::ServerWidget::changeLock | ( | bool | lock | ) |

virtual

This function is used by the server thread to handle locking of composites across several threads.

The protocol is rather complicated: the server thread reacts to a connection, creates a composite, calls changeLock(), this emits the signal "lockRequested", which is finally handled in the slot handleLocking(). The reason for this involved setup is the separation of server and GUI threads, which does not allow to safely lock the composites in the server thread.

## clear()

virtual void BALL::VIEW::ServerWidget::clear | ( |  | ) |

virtual

Explicit default initialization. Calls ConnectionObject::clear.

See also
  ConnectionObject::clear

Reimplemented from BALL::VIEW::ModularWidget.

## deactivate()

virtual void BALL::VIEW::ServerWidget::deactivate | ( |  | ) |

inline virtual

Stop the server.

Definition at line 173 of file serverWidget.h.

## dump()

virtual void BALL::VIEW::ServerWidget::dump | ( | std::ostream & | s = std::cout,
|  | Size | depth = 0 ) const

virtual

Dump the current state of this server to the output ostream with a dumping depth.

Parameters

  s | output stream where to output the state of this server
  depth | the dumping depth

See also
  ConnectionObject::dump

Reimplemented from BALL::VIEW::ModularWidget.

## finalizePreferencesTab()

virtual void BALL::VIEW::ServerWidget::finalizePreferencesTab | ( | Preferences & | preferences | ) |

virtual

Remove the preferences tab. This method removes the ServerPreferences tab of this server from the Preferences dialog of the MainControl. This method is called automatically by the method aboutToExit method of the class MainControl at the end of the application. See ModularWidget for more information concerning preferences tabs.

Parameters

  preferences | the Preferences dialog of the MainControl

See also
  aboutToExit
  ServerPreferences
  Preferences

Reimplemented from BALL::VIEW::ModularWidget.

## finalizeWidget()

virtual void BALL::VIEW::ServerWidget::finalizeWidget | ( | MainControl & | main_control | ) |

virtual

Remove the server widget. This method deletes the icon of this server and removes it from MainControl. This method will be called by aboutToExit of the class MainControl.

See also
  ModularWidget
  aboutToExit

Reimplemented from BALL::VIEW::ModularWidget.

## getObjectCreator() [1/2]

ObjectCreator & BALL::VIEW::ServerWidget::getObjectCreator | ( |  | ) |

Return the ObjectCreator.

## getObjectCreator() [2/2]

const ObjectCreator & BALL::VIEW::ServerWidget::getObjectCreator | ( |  | ) | const

Return the ObjectCreator, const version.

## getPort()

int BALL::VIEW::ServerWidget::getPort | ( |  | ) | const

Return the server port. Return the port of this server.

Returns
  int the port of this server

## handleLocking

void BALL::VIEW::ServerWidget::handleLocking | ( | bool | lock | ) |

slot

## initializePreferencesTab()

virtual void BALL::VIEW::ServerWidget::initializePreferencesTab | ( | Preferences & | preferences | ) |

virtual

Initialize a preferences tab for the server. This method creates the preferences tab ServerPreferences for this server and inserts it into the Preferences dialog of the MainControl. This method is called automatically by the method show of the class MainControl at the start of the application. See ModularWidget for more information concerning preferences tabs.

Parameters

  preferences | the Preferences dialog of the MainControl

See also
  show
  ServerPreferences
  Preferences

Reimplemented from BALL::VIEW::ModularWidget.

## initializeWidget()

virtual void BALL::VIEW::ServerWidget::initializeWidget | ( | MainControl & | main_control | ) |

virtual

Initialize the server widget. This method initializes the icon of this server and adds it to MainControl. This method will be called by show of the class MainControl.

See also
  ModularWidget
  show

Reimplemented from BALL::VIEW::ModularWidget.

## isValid()

virtual bool BALL::VIEW::ServerWidget::isValid | ( |  | ) | const

virtual

Internal state and consistency self-validation. Calls {ConnectionObject::isValid}.

Returns
  bool true if the internal state of this server is correct

See also
  ConnectionObject::isValid

Reimplemented from BALL::VIEW::ConnectionObject.

## lockRequested

void BALL::VIEW::ServerWidget::lockRequested | ( | bool | lock | ) |

signal

## registerObjectCreator()

void BALL::VIEW::ServerWidget::registerObjectCreator | ( | const ObjectCreator & | s | ) |

Register a ObjectCreator that is used for converting PersistentObject objects into Composite objects. Every ObjectCreator, that is still registered, when a ServerWidget instance is destructed, will be deleted.

See also
  ObjectCreator

## setPort()

void BALL::VIEW::ServerWidget::setPort | ( | const int | port | ) |

Set the server port.

Parameters

  port | the new port

## unregisterObjectCreator()

void BALL::VIEW::ServerWidget::unregisterObjectCreator | ( |  | ) |

Reset the ObjectCreator. After calling this method PersistentObject objects will be converted using the default ObjectCreator.

See also
  ObjectCreator